#include <conf.h>
#include <kernel.h>
#include <mq.h>
#include <timer.h>
#include <arp.h>

PROCESS arp () {
        /* init stuff */
        Arp.arc_ctrlq  = mqcreate(ARP_CTRL_QSIZE);
        Arp.arc_pinq   = mqcreate(ARP_CTRL_QSIZE);
        Arp.arc_poutq  = mqcreate(ARP_CTRL_QSIZE);
        Arp.arc_timerq = mqcreate(ARP_CTRL_QSIZE);
                 
        signal (Arp.arc_sem); /* init done, arp process started */
        tmset (ARP_TIMER_QUANTUM, Arp.arc_ctrlq, ARP_CMDTIMER);

        while (TRUE) {
                switch (mqrecv (Arp.arc_ctrlq)) {
                        case ARP_CMDTIMER:
                                arptimer ();
                                break;
                        case ARP_CMDPKTIN:
                                arpin ((struct ep *) mqrecv (Arp.arc_pinq));
                                break;
                        case ARP_CMDPKTOUT:
                                arpout((struct arp_entry *) mqrecv (Arp.arc_poutq));
                                break;
                }
        }
        return (OK);
}

