#include <conf.h>
#include <kernel.h>
#include <mark.h>
#include <bufpool.h>
#include <arp.h>
#include <stdio.h>

struct arp_control Arp;

void arpinit () {
        Arp.arc_sem = screate(0);                                             /* everything waits until 
                                                                                 ARP process starts up   */
        Arp.arc_entrypool = mkpool(sizeof(struct arp_entry), ARP_MAXENTRIES); /* arp entries buffer pool */
        Arp.arc_pinfopool = mkpool(sizeof(struct arp_pinfo), ARP_MAXWAITING); /* arp waitinf buffer pool */
        Arp.arc_tbl = NULL;                                                   /* arp list */
        
        resume (create ((int *)arp, ARPSTK, ARPPRIO, ARPNAME, 0, 0)); 
}

