#include <conf.h>
#include <kernel.h>
#include <arp.h>
#include <network.h>
#include <stdio.h>
#include <ipif.h>

void arpout(struct arp_entry *parp) {
        int   hlen;
        int   iface;
        u_char *data;
        struct ep *pep;
        struct arp_packet *packet;

        pep = (struct ep*) getbuf(Net.netpool);
        iface = parp->are_iface;
        hlen = nif[iface].ni_hwa.ha_len;
        packet = (struct arp_packet *) pep->ep_data;
        data = &(packet->ar_data);

        blkcopy(pep->ep_dst, nif[iface].ni_hwb.ha_addr, EP_ALEN);
        pep->ep_type = EPT_ARP;
         
        packet->ar_htype = hs2net((short) nif[iface].ni_hwtype);
        packet->ar_ptype = hs2net(EPT_IP);
        packet->ar_hlen  = hlen;
        packet->ar_plen  = sizeof(IPaddr);
        packet->ar_op    = hs2net(ARP_REQUEST);

        blkcopy(data, nif[iface].ni_hwa.ha_addr, hlen); data +=hlen;
        blkcopy(data, &ipif[iface].ipif_addr, sizeof(IPaddr)); data += sizeof(IPaddr);
        bzero(data, hlen); data += hlen;
        blkcopy(data, &(parp->are_ip), sizeof(IPaddr)); data += sizeof(IPaddr);
        
        pep->ep_len = (unsigned int) data - (unsigned int) &pep->ep_eh;
	pep->ep_outif = iface;
        ni_out (pep);
}

