#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <arp.h>
#include <stdio.h>

u_char arpshell_hwaddr[10];

COMMAND arpshell (int stdin, int stdout, int stderr,
              int nargs, char *args[]) {

        int    i;
        int    iface;
        IPaddr ipaddr;
        char   buffer[20];
        struct arp_entry *pentry;

        if (nargs==1) {
                fprintf (stdout, "Kernel ARP table\n");
                fprintf (stdout, "Address         HWaddr                 Iface Status Timer Retries\n");
                
                for (pentry = Arp.arc_tbl; pentry; pentry = pentry->are_next) {
                        fprintf (stdout, "%-15s ", iptochar (pentry->are_ip, buffer));
                        if (pentry->are_stat == ARP_STAT_VALID || 
                            pentry->are_stat == ARP_STAT_REVALID) {
                                for (i=0; i<nif[pentry->are_iface].ni_hwa.ha_len-1; i++) {
                                        fprintf(stdout, "%02x:", pentry->are_hwaddr[i]);
                                }
                                fprintf(stdout, "%02x", pentry->are_hwaddr[i++]);
                                for (; i<6; i++) fprintf(stdout, "   ");
                                fprintf(stdout, "         ");
                        } else 
                                fprintf(stdout, "%-26s","*");
                        fprintf(stdout, "%2d", pentry->are_iface);
                        fprintf(stdout, "%7d", pentry->are_stat);
                        fprintf(stdout, "%6d", pentry->are_timer);
                        fprintf(stdout, "%8d\n", pentry->are_retry);
                }
        }

        if (nargs==3) {
                ipaddr = chartoip(args[1]);
                iface = atoi(args[2]);
                arplookup(ipaddr, iface, arpshell_hwaddr, NULL, NULL);
                return OK;
        }
       
        if (nargs!=1)
                fprintf (stdout, "arp <protocol address> <interface>\n");        
        return OK;
}
