#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <i386.h>
#include <3c905.h>
#include <stdio.h>

/*#define DEBUG*/

int _3c905_cntl(pdev, func, arg)
struct devsw    *pdev;
int             func;
unsigned char   *arg;
{
    STATWORD    ps;
    struct      dev_3c905   *dev;
    u_short     iobase;
    int         rv = OK;

    dev = (struct dev_3c905*) pdev->dvioblk;
    iobase = dev->ed_iobase;

    disable(ps);
    
    switch (func) {
    case EPC_PROMON:    /* turn on promiscuous mode */
        dev->ed_proms = 1;

	_3c905_cmd(dev, _3C905_CMD_RXDISABLE, 0);
	_3C905_CMD(dev, _3C905_CMD_SETRXFILTER, _3C905_MSK_PROMISC);
	_3C905_CMD(dev, _3C905_CMD_RXENABLE, 0);

        break;

    case EPC_PROMOFF:   /* turn off promiscuous mode */
        dev->ed_proms = 0;

        _3c905_cmd(dev, _3C905_CMD_RXDISABLE, 0);
        _3C905_CMD(dev, _3C905_CMD_SETRXFILTER, _3C905_MSK_RXFILTER);
        _3C905_CMD(dev, _3C905_CMD_RXENABLE, 0);

        break;

    case EPC_MADD:      /* add a multicast address */
        rv = _3c905_mcadd(dev, arg);
        break;
 
    case EPC_MDEL:
        rv = _3c905_mcdel(dev, arg);
        break;

    default:
        rv = SYSERR;
    }

    restore(ps);

    if (rv == SYSERR)
        kprintf("eep_cntl: ** func=%d failed **\n", func);
    return rv;   
}
