#include <conf.h>
#include <kernel.h>
#include <i386.h>
#include <network.h>
#include <3c905.h>
#include <pci.h>
#include <stdio.h>

/*#define DEBUG*/

SYSCALL _3c905_rawrite (dev, pep)
struct dev_3c905* dev;
struct ep* pep;
{
    STATWORD       ps;
    struct eth_pd* epd, *prev;
    int            len;

#ifdef DEBUG
    kprintf("3c905: rawrite\n");
#endif
 
    len = pep->ep_len;

    /* get the dpd structure */
    disable(ps);

    if ((dev->ed_txend + 2) % _3C905_TXRING == dev->ed_txbegin) {
        restore(ps);
#ifdef DEBUG
        kprintf("3c905: buffer full: %d %d\n", dev->ed_txend, dev->ed_txbegin);
#endif
        freebuf(pep);
        return SYSERR;
    }

    prev          = &eth_txring[dev->ed_txend];
    dev->ed_txend = (dev->ed_txend + 1) % _3C905_TXRING;
    epd           = &eth_txring[dev->ed_txend];

    restore(ps);
 
    /* write the dpd structure */
    epd->pd_next   = 0;
    epd->pd_status = _3C905_FLG_TXINDICATE|_3C905_FLG_RNDUPDEFEAT | len;
    epd->pd_buffer = ((void*) pep) + sizeof(struct ehx);
    epd->pd_length = _3C905_FLG_LASTFRAG | len;

    /* send it to the nic */
    _3c905_cmd(dev, _3C905_CMD_DNSTALL, 0);
    prev->pd_next  = epd;
    prev        = (struct eth_pd*) inl(dev->ed_iobase + _3C905_OFF_DNLISTPTR);
    if (! prev)
        outl(dev->ed_iobase + _3C905_OFF_DNLISTPTR, (int)epd);
    _3C905_CMD(dev, _3C905_CMD_DNUNSTALL, 0);

    return OK;
}
