#include <conf.h>
#include <kernel.h>
#include <i386.h>
#include <network.h>
#include <3c905.h>
#include <pci.h>

/*#define DEBUG*/

SYSCALL _3c905_write (pdev, pep, len)
struct devsw* pdev;
struct ep* pep;
int len;
{
    struct dev_3c905* dev;

#ifdef DEBUG
    kprintf("3c905: write\n");
#endif

    if (pep == NULL || len > EP_MAXLEN) {
#ifdef DEBUG
        kprintf("pep = 0x%X  len = %d\n", pep, len);
#endif
        return SYSERR;
    }

    dev = &dev_eth;

    /* update the packet */
    blkcopy(pep->ep_src, dev->ed_paddr, EP_ALEN);
    pep->ep_len  = len;
    pep->ep_type = hs2net(pep->ep_type);

    return _3c905_rawrite(dev, pep);
}
