#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <stdio.h>
#include <eepro.h>

/*#define DEBUG*/
#define PRINTERRORS

/*------------------------------------------------------------------------
 * eep_write - write a single packet to an Intel EtherExpress PRO/10
 *------------------------------------------------------------------------
 */
int eep_write(pdev, pep, len)
struct devsw    *pdev;
struct ep       *pep;
int             len;
{
    struct ethdev	*ped;

#ifdef DEBUG
    kprintf("eep_write\n");
#endif

    ped = (struct ethdev *)pdev->dvioblk;
    if (ped->ed_ifnum < 0) {
        freebuf(pep);
        return SYSERR;
    }

    if (len > EP_MAXLEN) {
        nif[ped->ed_ifnum].ni_odiscard++;
#ifdef PRINTERRORS
        kprintf("eep_write: len(%d) > EP_MAXLEN(%d)\n", len, EP_MAXLEN);
#endif
        freebuf(pep);
        return SYSERR;
    }

    if (len < EP_MINLEN)
        len = EP_MINLEN;

    blkcopy(pep->ep_src, ped->ed_paddr, EP_ALEN);
    pep->ep_len = len;
    pep->ep_type = hs2net(pep->ep_type);

    if (eep_rawrite(ped, pep) == SYSERR) {
        nif[ped->ed_ifnum].ni_oqfull++;
        return SYSERR;
    }

    return OK;
}
