#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <i386.h>
#include <eepro.h>
#include <3c905.h>
#include <intel.h>
#include <pci.h>
#include <stdio.h>

/*#define DEBUG*/
extern int pci_init(void);
extern int find_pci_device(int, int, int);
extern int _3c905_init(struct devsw *);
extern int eep_probe(struct ethdev *, u_short);
extern int eep_init(struct devsw *);

/*------------------------------------------------------------------------
 * ethinit - find the Ethernet device
 *------------------------------------------------------------------------
 */
int ethinit(pdev)
struct devsw* pdev;
{
    struct ethdev	*ped;
    unsigned short      iobase;
    int			info;

    /*
     * Check for PCI BIOS
     */
    if (pci_init() == OK) {
	kprintf("ethinit: Found PCI BIOS\n");
	if ((info = find_pci_device(_3COM_3C905_DEVICE_ID, 
				    _3COM_VENDOR_ID, 0)) != SYSERR) {
	    /* found the 3com 3C905 card */
	    kprintf("ethinit: Found 3COM 3c905 card, configuring.\n");
            dev_eth.ed_pcidev = info;
	    return _3c905_init(pdev);
	} else if ((info = find_pci_device(_INTEL_PRO100_DEVICE_ID, 
					   _INTEL_VENDOR_ID, 0)) != SYSERR) {
	    /* found the Intel Pro/100 PCI card */
	    kprintf("ethinit: Intel Pro/100 S found -- can't configure\n");
	} else {
	    /* no recognized cards */
	    kprintf("ethinit: No recognized PCI ethernet cards found\n");
	}
    } else {
	kprintf("ethinit: No PCI BIOS\n");
    }

    ped = &eep[0];
    iobase = pdev->dvcsr = 0;         /* auto search */

    /*
     * Probe Intel Ether Express Pro ISA
     */
    if (eep_probe(ped, iobase) == SYSERR) {
        kprintf("** No EtherExpress PRO/10 card at 0x%x **\n", iobase);
        return SYSERR;
    }
    return eep_init(pdev);
}
