#ifndef _BOOTP_H_
#define _BOOTP_H_

#define BPOP_REQ	1
#define BPOP_REP	2

#define BOOTP_MAGIC	"\143\202\123\143"

/* Helga will return bootp options 1, 2, 3, 4, 6, 9, 13 */
#define BOOTPO_PAD		0x00
#define BOOTPO_END		0xFF
#define BOOTPO_NETMASK		0x01
#define BOOTPO_TIMEOFFSET	0x02
#define BOOTPO_ROUTER		0x03
#define BOOTPO_TIMESERVER	0x04
#define BOOTPO_DNS		0x06
#define BOOTPO_LOGSERVER	0x07
#define BOOTPO_LPRSERVER	0x09
#define BOOTPO_HOSTNAME		0x0C
#define BOOTPO_FILESIZ		0x0D

struct bootp {
	u_char		bp_op;
	u_char		bp_htype;
	u_char		bp_hlen;
	u_char		bp_hops;
	u_int		bp_xid;
	u_short		bp_secs;
	u_short		bp_flags;
	IPaddr		bp_ciaddr;
	IPaddr		bp_yiaddr;
	IPaddr		bp_siaddr;
	IPaddr		bp_giaddr;
	u_char		bp_chaddr[16];
	char		bp_sname[64];
	char		bp_file[128];
	u_char		bp_vend[64];
};

#endif /* _BOOTP_H_ */
