/* cmd.h */
#ifndef _CMD_H_
#define _CMD_H_

/* Declarations for all commands known by the shell */

struct	cmdent	{			/* entry in command table	*/
	char	*cmdnam;		/* name of command		*/
	Bool	cbuiltin;		/* Is this a builtin command?	*/
	int	(*cproc)();		/* procedure that implements cmd*/
};

extern	int
	x_bpool(),	x_creat(),	x_devs(),	x_exit(),
	x_help(),	x_kill(),	x_mem(),	x_printfc(),
	x_printmq(),	x_printtm(),	x_prompt(),	x_ps(),
	x_reboot(),	x_sleep(),	x_stacktrace(),	x_tmtest(),
	x_getbs(),	x_relbs(),	x_testbs();

/* Commands:	 name		Builtin?	procedure	*/

#define	CMDS 	{"bpool",	FALSE,		x_bpool},	\
		{"devs",	FALSE,		x_devs},	\
		{"exit",	TRUE,		x_exit},	\
		{"getbs",	FALSE,		x_getbs},	\
		{"help",	FALSE,		x_help},	\
		{"kill",	TRUE,		x_kill},	\
		{"logout",	TRUE,		x_exit},	\
		{"mem",		FALSE,		x_mem},		\
		{"printfc",	FALSE,		x_printfc},	\
		{"printmq",	FALSE,		x_printmq},	\
		{"printtm",	FALSE,		x_printtm},	\
		{"prompt",	TRUE,		x_prompt},	\
		{"ps",		FALSE,		x_ps},		\
		{"reboot",	TRUE,		x_reboot},	\
		{"relbs",	FALSE,		x_relbs},	\
		{"sleep",	FALSE,		x_sleep},	\
		{"stacktrace",	FALSE,		x_stacktrace},	\
		{"testbs",	FALSE,		x_testbs},	\
		{"tmtest",	FALSE,		x_tmtest},	\
		{"?",		FALSE,		x_help}

extern	struct	cmdent	cmds[];
#endif
