/* Functions for doing Internet checksums.  Used by cksumc and cksums. */
typedef uint16_t inet_cksum_value;

inet_cksum_value new_inet_cksum();

inet_cksum_value inet_cksum(uint8_t *data, uint64_t len);

typedef struct inet_stream_context_t {
    uint32_t sum;
    unsigned int buf_used;
    uint8_t buf;
} inet_stream_context;

inet_stream_context inet_stream_init();

void inet_stream(uint8_t *data, uint64_t len, inet_stream_context *context);

inet_cksum_value inet_stream_result(inet_stream_context *context);

int inet_cksum_len();

void inet_cksum_copy(uint8_t *dest, inet_cksum_value *value);

char *inet_cksum2str(inet_cksum_value *sum, char *str);
