#ifndef _IPOPT_H_
#define _IPOPT_H_

#include <ether.h>
#include <ip.h>

#define IPOPT_EOL       0x00
#define IPOPT_NOP       0x01
#define IPOPT_RR        0x07
#define IPOPT_TS        0x44
#define IPOPT_SEC       0x82
#define IPOPT_LSRR      0x83
#define IPOPT_SSRR      0x89
#define IPOPT_SID       0x88

#define IPOPT_TS_FLG    0x0f
#define IPOPT_TS_OFLW   0xf0

#define IPOPT_TS_ONLY   0x00
#define IPOPT_TS_SETA   0x01
#define IPOPT_TS_SETT   0x03

int ipopt(struct ep *pep, struct ip *pip);
int optlsrr (struct ep *pep, struct ip *pip, u_char *opt);
int optssrr (struct ep *pep, struct ip *pip, u_char *opt);
int optts (struct ep *pep, struct ip *pip, u_char *opt, IPaddr ourip);
int optrr (struct ep *pep, struct ip *pip, u_char *opt);
int optlocal (IPaddr addr);
void optfrag (struct ip *pip, struct ip *pipfrag);

#endif
