/* net.h */

#ifndef _NET_H_
#define _NET_H_

#include <netif.h>

/* High-level network definitions and constants */

#define NETBUFS		200		/* number of network buffers	*/
#define MAXNETBUF	EP_MAXLEN+sizeof(struct ehx)
					/* max network buffer length	*/
#define	NETFQ		3		/* size of input-to-output queue*/

/* Network input and output processes: procedure name and parameters */

#define	NETSTK		1000		/* stack size for network setup	*/
#define	STSTK		4096		/* stack size for network timer	*/
#define	NETPRI		100		/* network startup priority	*/
#define	NETIPRI		110		/* min network input priority	*/
#define	STPRI		100		/* network timer priority	*/
#define	NETNAM		"netstart"	/* name of network setup process*/
#define	STNAM		"slowtimer"	/* name of network timer   "	*/
#define	NETARGC		1		/* count of args to net startup	*/
#define	STARGC		0		/* count of args to net timer	*/

struct	netinfo	{			/* info and parms. for network	*/
	int	netpool;		/* network packet buffer pool	*/
};

extern	struct	netinfo	Net;		/* All network parameters	*/

/* This stringify MUST be indirected one level */
#define STRINGIFY(x) #x
#define LISTENPORT(port) ("passive:0.0.0.0:" STRINGIFY(port))

/* ANSI compliant function prototypes */

void ofaceinit(int iface);
PROCESS netinit(int userpid);
int initnif();
SYSCALL	getutim(unsigned long *timvar);
SYSCALL	getname(char *nam);
int getiname(int inum, char *nam);
Bool ethmatch(struct netif *pni, Eaddr pea);
int efaceinit(int iface);
int ni_in(struct netif *, struct ep *pep, int len);
void ni_out(struct ep *pep);
int bootp();

#endif
