#ifndef _NETIF_H_
#define _NETIF_H_

#define	NI_MAXHWA	14		/* max size of any hardware	*/
					/*  (physical) net address	*/
struct	hwa	{			/* a hardware address		*/
	int		ha_len;		/* length of this address	*/
	unsigned char	ha_addr[NI_MAXHWA]; 	/* the address		*/
};

#define	NI_LOCAL	0		/* index of local interface	*/
#define	NI_PRIMARY	1		/* index of primary interface	*/
#define NI_OTHER1       2
#define NI_OTHER2       3

#define	NI_MADD		0		/* add multicast (ni_mcast)	*/
#define	NI_MDEL		1		/* delete multicast (ni_mcast)	*/

#define	NIS_UP		0x01
#define	NIS_DOWN	0x02

/* Definitions of network interface structure (one per interface)	*/

struct	netif {				/* info about one net interface	*/
	char	ni_state;		/* interface states: NIS_ above	*/
	int	ni_mtu;			/* max transfer unit (bytes)	*/
	int	ni_hwtype;		/* hardware type (for ARP)	*/
	struct	hwa	ni_hwa;		/* hardware address of interface*/
	struct	hwa	ni_hwb;		/* hardware broadcast address	*/
	int	(*ni_mcast)();		/* multicast add/delete func.	*/
	int	ni_dev;			/* the Xinu device descriptor	*/
	int	ni_ipinq;		/* IP input queue		*/
	int	ni_outq;		/* (device) output queue	*/
	
        /* Stats */
	char	*ni_descr;		/* text description of hardware */
	long	ni_idiscard;		/* # dropped - input queue full	*/
	long	ni_ierrors;		/* # input packet errors	*/
	long	ni_inobuf;		/* # input - no buffer		*/
	long	ni_nin;			/* # input frames		*/

	long	ni_odiscard;		/* # output packets discarded	*/
	long	ni_oerrors;		/* # output packet errors	*/
	long	ni_oqfull;		/* # output - queue full	*/
	long	ni_nout;		/* # output frames		*/
	long	ni_tx_int;		/* # of TX interrupts		*/
	long	ni_tx_ok;		/* # of TX OKs			*/
    	long	ni_tx_max_collision;	/* # of TX exceeds max. collisions */
    	long	ni_tx_no_carrier;	/* # of lost carriers		*/
    	long	ni_tx_dma_underrun;	/* # of DMA underrun		*/
    	long	ni_tx_deffered;		/* # of defferred transmissions	*/
    	long	ni_tx_1_retry;		/* # of 1 TX collision		*/
    	long	ni_tx_n_retry;		/* # of more than 1 retries	*/
    	long	ni_tx_no_space;		/* # of lack of TX buffer space	*/
};

#define	NIF	Neth+Noth+1		/* # of interfaces, +1 for local*/
extern struct netif	nif[];

#endif
