#ifndef _UDP_H_
#define _UDP_H_

#define UDPP_ECHO       7
#define UDPP_DISCARD    9
#define UDPP_DAYTIME    13
#define UDPP_CHARGEN    19
#define UDPP_TIME       37
#define UDPP_DNS        53
#define UDPP_DOMAIN     53	/* IANA name */
#define UDPP_BOOTPS     67
#define UDPP_BOOTPC     68
#define UDPP_TFTP       69
#define UDPP_RIP        520
#define UDPP_ROUTER     520     /* INANA name */
#define UDPP_ANY	((u_short) (~0))

#define UDP_HLEN	8

#define UG_HLEN		12

#define UCB_FREE	0
#define UCB_OPEN	1
#define UCB_DELETING	2

#define UCBF_CKSUM	1
#define UCBF_TTL	2
#define UCBF_DEFAULT	(UCBF_CKSUM)

#define UDPC_CKSUM	1
#define UDPC_TTL	2
#define UDPC_BREAK	3

struct udp {
	u_short udp_src;
	u_short udp_dst;
	u_short udp_len;
	u_short udp_cksum;
	char udp_data[1];
};

struct ucb {
	int	ucb_state;
	int	ucb_flags;
	IPaddr	ucb_lip;
	IPaddr	ucb_rip;
	u_short	ucb_lport;
	u_short	ucb_rport;
	u_char	ucb_ttl;
	int	ucb_mq;
	int	ucb_dvnum;
	int	ucb_cookie;
};

struct udpdgram {
	IPaddr	ug_ip;
	u_short	ug_port;
	u_short	ug_len;
	int	ug_nif;
	char	ug_data[1];
};

struct udpcontrol {
	int udpdev;
	int devmutex;
};

extern struct ucb ucbtab[];
extern struct udpcontrol Udp;

u_short udpcksum (struct ip *pip, struct udp *pudp);

PROCESS udp ();

#endif /* _UDP_H_ */
