/* Generic checksuming wrapper functions.  Used by the cksum client and server
   for testing protocol implementations.
 */
#define CKSUM_INET      1
#define CKSUM_MD5       2

typedef union cksum_value_t {
    uint16_t inet;
    md5_digest md5;
} cksum_value;

typedef union cksum_context_t {
    inet_stream_context inet;
    md5_stream_context md5;
} cksum_context;


int cksum_len(int cksum_type);

cksum_value compute_cksum(int cksum_type, uint8_t *data, uint64_t len);

cksum_context cksum_stream_init(int cksum_type);
void cksum_stream(int cksum_type, uint8_t *data, uint64_t len,
    cksum_context *context);
cksum_value cksum_stream_result(int cksum_type, cksum_context *context);

void cksum_copy(int cksum_type, uint8_t *dest, cksum_value *value);

char *cksum2str(int cksum_type, cksum_value *value, char *str);
