#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <mq.h>
#include <stdio.h>

int icmpclose (struct devsw *pdev)
{
	struct icb *picb = &icbtab[pdev->dvminor];
	STATWORD ps;

	wait (Icmp.icmpmutex);
	if (picb->icb_state != ICB_OPEN) {
		signal (Icmp.icmpmutex);
		return SYSERR;
	}

	disable(ps);
	picb->icb_cookie++;
	restore(ps);
	mqdisable (picb->icb_mq);
	mqclear(picb->icb_mq, (int (*)(int))freebuf);
	picb->icb_state = ICB_FREE;

	signal (Icmp.icmpmutex);
	return OK;
}
