#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <stdio.h>

/* For icmp error packets, return proto field of original packet.
 * for icmp service packets, return IPP_ICMP
 * else, SYSERR
 */
int icmpgetproto (struct ep *pep)
{
	struct ip *pip = (struct ip *)pep->ep_data, *pip2;
	struct icmp *picmp = (struct icmp *) ((char *) pip + IP_HLEN(pip));

	switch (picmp->icmp_type) {
	case ICMPT_DESTUR:
	case ICMPT_TIMEX:
	case ICMPT_PARAM:
	case ICMPT_SRCQ:
		pip2 = (struct ip *) ((char *)picmp + ICMP_HLEN);
		return pip2->ip_proto;
	case ICMPT_ECHORP:
	case ICMPT_ECHORQ:
	case ICMPT_MASKRP:
	case ICMPT_MASKRQ:
	case ICMPT_TSRP:
	case ICMPT_TSRQ:
	case ICMPT_RAD:
	case ICMPT_RSEL:
	case ICMPT_REDIRECT:
		return IPP_ICMP;
	default:
		return SYSERR;
	}
}
