#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <mq.h>

int icmpmopen (struct devsw *pdev, void *arg2, void *arg3)
{
	struct icmpconn *conn = (struct icmpconn *) arg2;
	int i;
	int dvnum;

	wait (Icmp.icmpmutex);
	for (i = 0; i < Nicmp; i++) {
		if (icbtab[i].icb_state == ICB_OPEN
		    && icmpconn_eq(&(icbtab[i].icb_conn), conn)) {
		    	signal (Icmp.icmpmutex);
			return SYSERR;
		}
	}
	for (i = 0; i < Nicmp; i++) {
		if (icbtab[i].icb_state == ICB_FREE)
			break;
	}
	if (i == Nicmp) {
		signal (Icmp.icmpmutex);
		return SYSERR;
	}

	mqenable (icbtab[i].icb_mq);
	icbtab[i].icb_conn = *conn;
	dvnum = icbtab[i].icb_dvnum;
	icbtab[i].icb_state = ICB_OPEN;
	signal (Icmp.icmpmutex);

	return dvnum;
}
