#include <conf.h>
#include <kernel.h>
#include <mq.h>
#include <network.h>
#include <stdio.h>

/* Icmp read is just like ipread, reader must freebuf (pep) */

int icmpread (struct devsw *pdev, u_char *data, int len)
{
	struct icb *picb = &icbtab[pdev->dvminor];
	struct ep *pep;
	STATWORD ps;
	int cookie;

	if (data == NULL || len != sizeof (struct ep *))
		return SYSERR;

	wait (Icmp.icmpmutex);
	if (picb->icb_state != ICB_OPEN) {
		signal (Icmp.icmpmutex);
		return SYSERR;
	}
	disable(ps);
	cookie = picb->icb_cookie;
	signal (Icmp.icmpmutex);

	if (cookie != picb->icb_cookie) {
		restore(ps);
		return SYSERR;
	}

	if ((pep = (struct ep *)mqrecv (picb->icb_mq)) == (struct ep*)SYSERR) {
		restore(ps);
		return SYSERR;
	}
	restore(ps);

	*(struct ep **)data = pep;
	return OK;
}
