#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <ipif.h>
#include <iproute.h>
#include <stdio.h>

void icmpredirect (struct ep *pep, struct ip *pip, struct icmp *picmp)
{
	struct ip *pdata = (struct ip*) picmp->icmp_data;
	/* TODO: more sanity checks would be good */
	if (Ip.forward == 0
	    && (pip->ip_src & ipif[pep->ep_inif].ipif_mask)
			== ipif[pep->ep_inif].ipif_net
	    && (picmp->icmp_misc & ipif[pep->ep_inif].ipif_mask)
			== ipif[pep->ep_inif].ipif_net) {

		wait (Route.ri_wsem);
		rtdelnb (pdata->ip_dst, RT_IPFULL);
		rtaddnl (pdata->ip_dst, RT_IPFULL, picmp->icmp_misc,
			pep->ep_inif, 1, ICMP_REDIRECT_TIMEOUT, 0, TRUE);
		signal (Route.ri_wsem);
		rtcommit ();
	}

	freebuf (pep);
}
