#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <ipif.h>


/*
 * iplocal
 * 
 * returns true if the given address is a local address, false otherwise
 */
int iplocal (int nif, IPaddr addr)
{
	struct ipif *pif;
	int i;

	if ((addr == IPADDR_BCAST && nif != NI_LOCAL)
	    || (nif != NI_LOCAL && addr == ipif[nif].ipif_bcast)
	    || ipif[nif].ipif_addr == IPADDR_ANY)
		return TRUE;
	for (i = 0; i < NIF; i++) {
		pif = &ipif[i];
		if (addr == pif->ipif_addr)
			return TRUE;
		if (addr == pif->ipif_bcast && i == nif)
			return TRUE;
	}
	return FALSE;
}
