#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <ip.h>
#include <ipif.h>
#include <iproute.h>

int iplookup(struct ep *pep) {
        struct route *prt;

        if (pep == NULL) return SYSERR;
        prt = rtget(((struct ip *)(pep->ep_data))->ip_dst);
        if (prt) {
                pep->ep_outif = prt->rt_ifnum;
                if (prt->rt_gw == ipif[pep->ep_outif].ipif_addr)
                        pep->ep_nexthop = ((struct ip *)(pep->ep_data))->ip_dst;
                else
                        pep->ep_nexthop = prt->rt_gw;
                pep->ep_flags = pep->ep_flags | EPF_ROUTED;
                rtfree (prt);
		return OK;
        }

        return SYSERR;
}
