#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <ip.h>
#include <iproute.h>

int ipmcntl (struct devsw *pdev, int func, int arg)
{
        int i;
        Eaddr emaddr;

        if (!IP_ISMULTI(arg)) return SYSERR;

        switch (func) {
        case IPC_MJOIN:                
                rtadd (arg, RT_IPFULL, arg, NI_LOCAL, RT_DFLT_METRIC, RT_TTLINF, 0, TRUE);
                for (i=0;i<NIF;i++)
                        if (nif[i].ni_mcast!=NULL)
                                nif[i].ni_mcast (NI_MADD, nif[i].ni_dev, emaddr, arg);
                return OK;
        case IPC_MLEAVE:
                rtdel (arg, RT_IPFULL);
                for (i=0;i<NIF;i++)
                        if (nif[i].ni_mcast!=NULL)
                                nif[i].ni_mcast (NI_MDEL, nif[i].ni_dev, emaddr, arg);
                return OK;
        }
        return SYSERR;
}

