#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <arp.h>
#include <ipif.h>
#include <iproute.h>
#include <mq.h>
#include <stdio.h>
#include <bufpool.h>

struct ipif ipif[NIF];
struct ipcontrol Ip;

int ipminit ()
{
	int i;

        arpinit();
        rtinit();        

	for (i = 0; i < NIF; i++) {
		switch (i) {
		case NI_LOCAL:
			ipif[i].ipif_addr = hl2net (0x7f000001);
			ipif[i].ipif_mask = hl2net (0xff000000);
			break;
		default:
			ipif[i].ipif_addr = IPADDR_ANY;
			ipif[i].ipif_mask = hl2net (0xffffffff);
			break;
		}
		ipif[i].ipif_net = ipif[i].ipif_addr & ipif[i].ipif_mask;
		ipif[i].ipif_bcast = ipif[i].ipif_addr | ~ipif[i].ipif_mask;
	}

	Ip.fastipmq = mqcreate (IP_FQSIZE);
	Ip.slowipmq = mqcreate (IP_SQSIZE);
	Ip.devmutex = screate (1);

	Ip.forward = 1;

	Ip.mbpool = mkpool (IP_MEDBUFSZ, IP_NMEDBUF);
	Ip.lbpool = mkpool (IP_LRGBUFSZ, IP_NLRGBUF);

	Ip.nfrags = 0;
	for (i = 0; i < IPFC_N; i++)
		ipfctab[i].head = NULL;

	resume (create ((int *)fastip, 512, 90, "fastip", 0, NULL));
	resume (create ((int *)slowip, 512, 80, "slowip", 0, NULL));

	return OK;
}
