#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <mq.h>
#include <stdio.h>

void iprecv (struct ep *pep)
{
	struct ip *pip = (struct ip *)pep->ep_data;

	/* Check basic validity */
	if (pep->ep_ehx.ehx_len < sizeof(struct eh) + IP_MINHLEN
	    || pep->ep_ehx.ehx_len < sizeof(struct eh) + net2hs (pip->ip_len)
	    || pip->ip_ver != 4 || IP_HLEN(pip) < IP_MINHLEN) {
		freebuf (pep);
		return;
	}
	if (mqsend (Ip.fastipmq, (int)pep) == SYSERR)
		freebuf (pep);
}
