#include <conf.h>
#include <kernel.h>
#include <network.h>

/*
 * ipttl
 *
 * Decrements the IP TTL, updates the checksum, and returns the new TTL
 */
inline int ipttl (struct ip *pip)
{
	unsigned int adjust;

	if (pip->ip_ttl == 0)
		return 0;

	adjust = pip->ip_cksum;
	adjust += ((unsigned short *)pip)[4];
	pip->ip_ttl--;
	adjust -= ((unsigned short *)pip)[4];
	adjust = (adjust & 0xffff) + (adjust >> 16);
	pip->ip_cksum = adjust;
	return pip->ip_ttl;
}
