#include <conf.h>
#include <kernel.h>
#include <ipopt.h>

void optfrag(struct ip *pip, struct ip *pipfrag) {
        int i = 0, j = 0, olen;
        while (i < IP_HLEN(pip) - IP_MINHLEN) {
                switch (pip->ip_data[i]) {
                case IPOPT_EOL:
                case IPOPT_NOP:
                        i++;
                        break;
                case IPOPT_RR:                                                
                case IPOPT_TS:
                        i += pip->ip_data[i+1];
                        break;
                case IPOPT_SEC:
                case IPOPT_LSRR:
                case IPOPT_SSRR:
                case IPOPT_SID:
                        olen = pip->ip_data[i+1];
                        blkcopy (&pipfrag->ip_data[j], &pip->ip_data[i], 
                                 olen);
                        j += olen;
                        while ((j & 0x03) != 0x00) 
                                pipfrag->ip_data[j++] = IPOPT_NOP;
                        break;
                }
        }

        if (j==0) {pipfrag->ip_hlen = IP_MINHLEN >> 2; return; }
        if ((j & 0x03) != 0x00) pipfrag->ip_data[j++] = IPOPT_EOL;
        pipfrag->ip_hlen = (IP_MINHLEN >> 2) + ((j-1) >> 2);
        return;
}
