#include <conf.h>
#include <kernel.h>
#include <ip.h>
#include <ipif.h>
#include <ipopt.h>
#include <icmp.h>

int optts (struct ep *pep, struct ip *pip, u_char *opt, IPaddr ourip) {
        u_char *plen    = opt+1;
        u_char *pointer = opt+2;
        u_char *oflwflg = opt+3;
        u_char *pend    = opt + *plen;
        unsigned int  *pts     = (unsigned int *) (opt + *pointer - 1);
        u_char overflow;
        unsigned long timeval;

        gettime ((long *)&timeval);

        switch (*oflwflg & IPOPT_TS_FLG) {
        case IPOPT_TS_ONLY:
                if ((u_char *)pts + sizeof(int) < pend) {
                        *pts = timeval;
                        *pointer += sizeof (unsigned int);
                }
                break;
        case IPOPT_TS_SETA:
                if ((u_char *)pts + sizeof (IPaddr) + sizeof (int)) {
                        if (ourip != IPADDR_ANY) {
                                *pts = ourip;
                                *(pts+1) = timeval;
                        } else {
                                if (!(pep->ep_flags & EPF_ROUTED))
                                        if (iplookup(pep) == SYSERR) {
                                                icmpreply (ICMPT_DESTUR, 
                                                        ICMPC_NETUR, 0, pep);
                                                return SYSERR;
                                        }
                                *pts = ipif[pep->ep_outif].ipif_addr;
                                *(pts+1) = timeval;
                        }
                        *pointer += sizeof (unsigned int) + sizeof (IPaddr);
                } else {
                        overflow = (*oflwflg & IPOPT_TS_OFLW) >> 4;
                        overflow++;
                        *oflwflg = (*oflwflg & IPOPT_TS_FLG) | overflow;
                }
                break;
        case IPOPT_TS_SETT:
                if ((u_char *)pts + sizeof (IPaddr) + sizeof (int)) {
                        if (optlocal(*pts)) {
                                *(pts+1) = timeval;
                                *pointer += sizeof(unsigned int) + 
                                            sizeof (IPaddr);
                        }
                } else {
                       overflow = (*oflwflg & IPOPT_TS_OFLW) >> 4;
                       overflow++;
                       *oflwflg = (*oflwflg & IPOPT_TS_FLG) | overflow;
                }
                break;
        default:
                icmpreply (ICMPT_PARAM, ICMPC_POINT, 
                        (int) opt - (int) pip, pep);
                return SYSERR;
        }
        return OK;
}
