#include <conf.h>
#include <kernel.h>
#include <iproute.h>

int rtdel (IPaddr prefix, IPaddr mask) {
        int rv;
        wait (Route.ri_wsem);
        rv = rtdelnb (prefix, mask);
        signal (Route.ri_wsem);
        rtcommit();
        return rv;
}

int rtdelnb (IPaddr prefix, IPaddr mask)
{
        struct route *prt, *prev;
        struct route *srt;
        
        prev = NULL;
        for (prt=RT_PHEAD(Route.ri_working); prt; 
                        prt=RT_PNEXT(Route.ri_working, prt))
                if (prefix == prt->rt_net && mask == prt->rt_mask)
                        break;
                else 
                        prev = prt;

        if (!prt) {
                return SYSERR;
        }

        prt->rt_flags |= RTF_CHANGED;
        if (Route.ri_havegc) {
                prt->rt_metric = RT_METRICINF;
                prt->rt_ttl = RT_TTLGC;
                return OK;
        }

        for (srt=RT_PNEXT(Route.ri_working, prt); srt; 
                        srt=RT_PNEXT(Route.ri_working, srt))
                if (RT_ISPREFIXOF(prt, srt)) {
                        if (srt->rt_iprefix == prt->rt_iself)  
                                srt->rt_iprefix = prt->rt_iprefix;
                } else break;

        if (prev)
                prev->rt_inext = prt->rt_inext;
        else
                Route.ri_working->rtb_irlist = prt->rt_inext;

        prt->rt_inext = Route.ri_working->rtb_ifree;
        Route.ri_working->rtb_ifree = prt->rt_iself;

        return OK; 
}

