#include <conf.h>
#include <kernel.h>
#include <iproute.h>

int rtfree(struct route *prt)
{
        struct rttable *ri_lookup;

        if (!prt) return SYSERR;

        ri_lookup = (struct rttable *) (((char *) prt)
                        - sizeof(struct route)*(prt->rt_iself));

        wait (Route.ri_rsem);
        if (prt && --ri_lookup->rtb_rcount==0 && 
                     ri_lookup == Route.ri_working)
                signal (Route.ri_refsem);
        signal (Route.ri_rsem);
        return OK;
}

