#include <conf.h>
#include <kernel.h>
#include <iproute.h>

int rtisbrc(IPaddr);

struct route *rtget(IPaddr dest)
{
        struct route *prt, *srt;
        u_int node, skip, branch;
        u_int isleaf, index;
        u_int p;
        IPaddr dest_ho;

        struct rttable *ri_lookup;

        dest_ho = net2hl(dest);
        
        wait (Route.ri_rsem);
        ri_lookup = Route.ri_lookup;
        ri_lookup->rtb_rcount++;        
        signal (Route.ri_rsem);

        /* walk through the lc-trie */

        srt=NULL;
        if (ri_lookup->rtb_trie[0]!=0) {
                p=0;
                node = ri_lookup->rtb_trie[0];
                branch = RT_BITEXTRACT(node, 0, 5);
                skip = RT_BITEXTRACT(node, 5, 5);
                isleaf = RT_BITEXTRACT(node, 10, 1);
                index  = RT_BITEXTRACT(node, 11, 21);
                while(!isleaf) {
                        node = ri_lookup->rtb_trie[index + RT_BITEXTRACT(dest_ho, p+skip, branch)];
                        p += (skip+branch);
                        branch = RT_BITEXTRACT(node, 0, 5);
                        skip = RT_BITEXTRACT(node, 5, 5);
                        isleaf = RT_BITEXTRACT(node, 10, 1);
                        index = RT_BITEXTRACT(node, 11, 21);
                }
                srt = ri_lookup->rtb_prefix[index];
        }

        for (prt=srt; prt; prt=RT_PNPREFIX(ri_lookup, prt)) {
                if (prt->rt_ttl == 0) continue;
                if (prt->rt_metric >= RT_METRICINF) continue;
                if ((dest & prt->rt_mask) != prt->rt_net) continue;
                break;
        }               

        wait (Route.ri_rsem);
        if (!prt && --ri_lookup->rtb_rcount == 0 && 
                    ri_lookup == Route.ri_working)
                signal (Route.ri_refsem);
        signal (Route.ri_rsem);
        return prt;
}

