#include <conf.h>
#include <kernel.h>
#include <iproute.h>

struct rtinfo Route;

void rtinit_table(struct rttable *prtable) {
        int i;

        prtable->rtb_ifree = 0;
        prtable->rtb_irlist = RT_IEND;
       
        prtable->rtb_rcount = 0; 
        for (i=0;i<RT_NROUTES;i++) {
                prtable->rtb_table[i].rt_iself = i;
                prtable->rtb_table[i].rt_inext = i+1;
        }
        
        prtable->rtb_table[i-1].rt_inext = RT_IEND;
}

void rtinit(void)
{      
        Route.ri_rsem = screate (1);
        Route.ri_wsem = screate (1);
        Route.ri_refsem = screate (0);

        Route.ri_havegc = FALSE;
        
        wait(Route.ri_wsem);
        wait(Route.ri_rsem);
        
        Route.ri_lookup  = (struct rttable *) getmem(sizeof(struct rttable));
        Route.ri_working = (struct rttable *) getmem(sizeof(struct rttable));

        rtinit_table(Route.ri_working);
        rttrie();
        blkcopy(Route.ri_lookup, Route.ri_working, sizeof(struct rttable));

        signal(Route.ri_rsem);
        signal(Route.ri_wsem);
}
