#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <stdio.h>
#include <dns.h>

/* Parse a connection spec (e.g. active:www.google.com:80)
 * This needs a better name. */
int cspecparse (char *spec, IPaddr *addr, u_short *port, int *active)
{
	char *begin, *end, host[HOSTNAMELEN];

	if ((begin = strchr (spec, ':')) == NULL)
		return SYSERR;
	begin++;
	if ((end = strchr (begin, ':')) == NULL)
		return SYSERR;
	if (end - begin > HOSTNAMELEN - 1)
		return SYSERR;

	bzero (host, sizeof(host));
	strncpy (host, begin, end - begin);
	if (gethostbyname (addr, host) == SYSERR)
		return SYSERR;
	*port = atoi (++end);

	if (*spec == 'a')
		*active = 1;
	else if (*spec == 'p')
		*active = 0;
	else
		return SYSERR;

	return OK;
}
