#include <conf.h>
#include <kernel.h>
#include <arp.h>
#include <network.h>

/*------------------------------------------------------------------------
 * efaceinit --  initialize the real Ethernet interface
 *------------------------------------------------------------------------
 */
int efaceinit(int iface)
{
    extern int	ethmcast();
    struct ethdev_comm *ped = (struct ethdev_comm *) 
				devtab[nif[iface].ni_dev].dvioblk;
    struct netif   *pni = &nif[iface];

    if (ped->edc_ifnum < 0) {
        /* card init failed */
        return SYSERR;
    }

    blkcopy(pni->ni_hwa.ha_addr, ped->edc_paddr, EP_ALEN);
    blkcopy(pni->ni_hwb.ha_addr, ped->edc_bcast, EP_ALEN);
    pni->ni_descr = ped->edc_descr;
    pni->ni_hwtype = ARP_HTYPE_ETHER;
    pni->ni_hwa.ha_len = EP_ALEN;
    pni->ni_hwb.ha_len = EP_ALEN;
    pni->ni_mtu = EP_DLEN;
    pni->ni_outq = ped->edc_outq;
    pni->ni_mcast = ethmcast;
    /* pni->ni_state = NIS_UP; */
    ped->edc_ifnum = iface;

    return(OK);
}
