#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <ctype.h>
#include <dns.h>
#include <stdio.h>

int isdottedquad (char *addr)
{
	int ndots, ndigits;
	for (ndots = ndigits = 0; *addr != '\0'; addr++) {
		if (*addr == '.') {
			if (ndigits < 1 || ndigits > 3)
				return SYSERR;
			ndots++;
			ndigits = 0;
		} else if (isdigit (*addr)) {
			ndigits++;
		} else {
			return SYSERR;
		}
	}
	if (ndots != 3 || ndigits < 1 || ndigits > 3)
		return SYSERR;
	return OK;
}

int gethostbyname (IPaddr *addr, char *host)
{
	char buf[HOSTNAMELEN];
	char *c;
	int hlen;
	if (isdottedquad (host) == OK) {
		*addr = chartoip (host);
		return OK;
	}

	for (c = host; *c != '\0' && *c != '.'; c++);
	if (*c != '.') {
		hlen = strlen (host);
		if (hlen >= sizeof (buf) - strlen (DNS_SUFFIX))
			return SYSERR;
		strcpy (buf, host);
		strcpy (buf + hlen, DNS_SUFFIX);
		host = buf;
	}

	if ((*addr = hosttoip (host)) == IPADDR_ANY)
		return SYSERR;
	return OK;
}
