/* ni_in.c - ni_in */

#include <conf.h>
#include <kernel.h>
#include <bufpool.h>
#include <network.h>
#include <arp.h> 

/*------------------------------------------------------------------------
 *  ni_in - network interface input function
 *------------------------------------------------------------------------
 */
int ni_in(struct netif *pni, struct ep *pep, int len)
{
        pep->ep_flags = 0;
        /* Ethernet type for othernets fixup */
        if (pep->ep_inif == NI_OTHER1 || pep->ep_inif == NI_OTHER2) {
                if ((pep->ep_type & EPT_OTHERMASK) != EPT_OTHERMASK) {
                        freebuf(pep);
                        return OK;
                } else 
                        pep->ep_type = pep->ep_type & (~EPT_OTHERMASK);
        }
        switch (pep->ep_type) {
        case EPT_ARP:
                arprecv(pep);
                break;
        case EPT_IP:
                iprecv(pep);
                break;
        default:
	        freebuf(pep);
        }
        return OK;
}
