#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <stdio.h>

void ni_out (struct ep *pep) {
	if (pep->ep_outif == NI_LOCAL) {
		kprintf ("bogus ni_out for NI_LOCAL\n");
		freebuf (pep);
		return;
	}
        /* Ethernet type for othernet packets fixup */
        if (pep->ep_outif == NI_OTHER1 || pep->ep_outif == NI_OTHER2)
                pep->ep_type = pep->ep_type | EPT_OTHERMASK;
        if (nif[pep->ep_outif].ni_state==NIS_UP)
                write (nif[pep->ep_outif].ni_dev, pep, pep->ep_len);
        else
                freebuf (pep);
}

