#include <conf.h>
#include <kernel.h>
#include <proc.h>
#include <io.h>
#include <stdio.h>
#include <network.h>
#include <page_server.h>

int get_pagedev ()
{
	struct pentry *pptr = &proctab[getpid()];

	if (!isbaddev (pptr->ppagedev))
		return pptr->ppagedev;

	if (PSinfo.psip == IPADDR_ANY)
		return SYSERR;

	if (PSinfo.psspec[0] == '\0') {
		strcpy (PSinfo.psspec, "a:");
		iptochar (PSinfo.psip, PSinfo.psspec + 2);
		sprintf (PSinfo.psspec + strlen (PSinfo.psspec),
			 ":%d", SERVER_PORT);
	}

	if ((pptr->ppagedev = open (UDP, (int)PSinfo.psspec, 0)) == SYSERR)
		return SYSERR;

	return pptr->ppagedev;
}
