#include <conf.h>
#include <kernel.h>
#include <paging.h>
#include <stdio.h>

COMMAND	x_getbs(stdin, stdout, stderr, nargs, args) 
int	stdin, stdout, stderr, nargs;
char	*args[];
{

  bsd_t bs;
  int size;

  if (nargs != 3) {
    fprintf(stderr, "usage: %s ID size\n", args[0]);
    return OK;
  }

  bs = atoi(args[1]);
  size = atoi(args[2]);

  fprintf(stdout, "requesting get_bs(%d, %d) ->", bs, size);
  size = get_bs(bs, size);
  
  if (size == SYSERR) 
    fprintf(stdout, " SYSERR\n");
  else
    fprintf(stdout, " %d\n", size);

  return OK;
}
