#include <conf.h>
#include <kernel.h>
#include <timer.h>
#include <mq.h>
#include <stdio.h>

extern int mqsem;

COMMAND x_printmq(int stdin, int stdout, int stderr, int nargs, char *args[])
{
	STATWORD ps;
	int mq, i;
	int mq_sem;
	int mq_qlen;
	int mq_count;
	int mq_first;
	int mq_msgs[100];
	int mq_state;

	for (mq = 0; mq < NMQ; mq++) {
		wait (mqsem);
		disable (ps);

		mq_sem = mqtab[mq].mq_sem;
		mq_state = mqtab[mq].mq_state;
		mq_qlen = mqtab[mq].mq_qlen;
		mq_count = mqtab[mq].mq_count;
		mq_first = mqtab[mq].mq_first;
		for (i = 0; i < min(100, mq_qlen); i++)
			mq_msgs[i] = mqtab[mq].mq_msgs[i];
		
		restore (ps);
		signal (mqsem);

		if (mq_state != 0/*MQ_FREE*/) {
			fprintf (stdout, "mq[%d] sem=%d state=%d:", mq, mq_sem, mq_state);
			for (i = 0; i < min(100, mq_count); i++) {
				fprintf (stdout, " %d", mq_msgs[(mq_first + 1) % mq_qlen]);
			}
			fprintf (stdout, "\n");
		}
	}

	return 0;
}
