#include <conf.h>
#include <kernel.h>
#include <timer.h>
#include <mq.h>
#include <stdio.h>

extern int tmhead;
extern int tmlock;
extern int tmsem;

COMMAND x_printtm(int stdin, int stdout, int stderr, int nargs, char *args[])
{
	STATWORD ps;
	int tmmq[NTIMERS];
	int tmt[NTIMERS];
	int ntm = 0, i;
	int cur;
	int tpend;
	int tmsem_cnt;
	int tmlock_cnt;

	wait (tmlock);
	disable (ps);
	tpend = tmpending;

	cur = tmhead;
	while (cur != BADTIMER) {
		tmmq[ntm] = tmtab[cur].tm_mq;
		tmt[ntm] = tmtab[cur].tm_remain;
		cur = tmtab[cur].tm_next;
		ntm++;
	}

	tmsem_cnt = scount(tmsem);
	tmlock_cnt = scount(tmlock);

	restore (ps);
	signal (tmlock);

	fprintf (stdout, "timers tpend=%d tmsem=%d(%d) tmlock=%d(%d)[t, mq]:",
		tpend, tmsem, tmsem_cnt, tmlock, tmlock_cnt+1);

	for (i = 0; i < ntm; i++) {
		fprintf (stdout, " [%d, %d]", tmt[i], tmmq[i]);
	}
	fprintf (stdout, "\n");

	return 0;
}
