#include <conf.h>
#include <kernel.h>
#include <paging.h>
#include <stdio.h>
#include <network.h>
#include <i386.h>
#include <page_server.h>

COMMAND	x_testbs(stdin, stdout, stderr, nargs, args) 
int 	stdin, stdout, stderr;
int     nargs;
char	*args[];
{

  bsd_t			bs;
  unsigned int		pageno;
  unsigned char		*pg, *pg2;
  int			i, rv;
  extern unsigned long	ctr1000;

  if (nargs != 3) {
    fprintf(stderr, "usage: %s ID page\n", args[0]);
    return OK;
  }

  srand(ctr1000);

  bs = atoi(args[1]);
  pageno = atoi(args[2]);

  pg = (unsigned char *) getmem(NBPG);

  if (pg == (unsigned char *)SYSERR) {
    fprintf(stderr, "x_testbs: getbuf returns SYSERR\n");
    return SYSERR;
  }

  pg2 = (unsigned char *) getmem(NBPG);

  if (pg2 == (unsigned char *)SYSERR) {
    fprintf(stderr, "x_testbs: getbuf returns SYSERR (2)\n");
    freemem((struct mblock *)pg, NBPG);
    return SYSERR;
  }

  fprintf(stdout, "Generating page...\n");

  for (i = 0; i < NBPG; i++) {

    *(pg + i) = rand() % 255;

  }

  fprintf(stdout, "requesting write_bs(pg, %d, %d) ->", bs, pageno);

  rv = write_bs((char *)pg, bs, pageno);

  if (rv == OK)
    fprintf(stdout, " OK\n");
  else if (rv == SYSERR) {
    freemem((struct mblock *)pg, NBPG);
    freemem((struct mblock *)pg2, NBPG);
    fprintf(stdout, " SYSERR\n");
    return SYSERR;
  }
  else { 
    fprintf(stdout, " %d\n", rv);
    freemem((struct mblock *)pg, NBPG);
    freemem((struct mblock *)pg2, NBPG);
    return SYSERR;
  }

  fprintf(stdout, "requesting read_bs(pg2, %d, %d) ->", bs, pageno);

  rv = read_bs((char *)pg2, bs, pageno);

  if (rv == SYSERR) {
    fprintf(stdout, " SYSERR\n");
    freemem((struct mblock *)pg, NBPG);
    freemem((struct mblock *)pg2, NBPG);
    return SYSERR;
  }

  else if (rv == OK) {
    fprintf(stdout, " OK\nComparing pages...\n");
    
    for (i = 0; i < NBPG; i++) {
      
      if (*(pg + i) != *(pg2 + i))
	fprintf(stdout, "Wrong value at byte %d\n", i);

    }

    fprintf(stdout,"Done.\n");
    freemem((struct mblock *)pg, NBPG);
    freemem((struct mblock *)pg2, NBPG);
    return OK;
  }

  else {
    fprintf(stdout, " %d (?)\n", rv);
    freemem((struct mblock *)pg, NBPG);
    freemem((struct mblock *)pg2, NBPG);
    return SYSERR;
  }

}
