#include <conf.h>
#include <kernel.h>
#include <timer.h>
#include <mq.h>
#include <stdio.h>

COMMAND x_tmtest(int stdin, int stdout, int stderr, int nargs, char *args[])
{
	int mq, msg;

	if ((mq = mqcreate (5)) == SYSERR) {
		fprintf (stderr, "Could not create message queue\n");
		return SYSERR;
	}
	if ((tmset (1000, mq, 0xdeadbeef)) != OK) {
		fprintf (stderr, "Could not set timer\n");
		return SYSERR;
	}
	if ((msg = mqrecv (mq)) != 0xdeadbeef) {
		fprintf (stderr, "Bogus message %x\n", msg);
		return SYSERR;
	}
	printf ("simple timer success\n");
	if ((tmset (2000, mq, 0x1)) != OK) {
		fprintf (stderr, "Could not set timer 1\n");
		return SYSERR;
	}
	if ((tmset (1000, mq, 0x2)) != OK) {
		fprintf (stderr, "Could not set timer 2\n");
		return SYSERR;
	}
	if ((tmdel (mq, 0x2)) != OK) {
		fprintf (stderr, "Could not delete timer 2\n");
		return SYSERR;
	}
	if ((msg = mqrecv (mq)) != 0x1) {
		fprintf (stderr, "Bogus message %x\n", msg);
		return SYSERR;
	}
	printf ("simple tmdel success\n");
	return 0;
}
