#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <mq.h>
#include <stdio.h>

PROCESS udp ()
{
	struct ep *pep;
	struct ip *pip;
	struct udp *pudp;
	int i, partial;

	while (1) {
		if (read (Udp.udpdev, &pep, sizeof(pep)) == SYSERR)
			return SYSERR;
		pip = (struct ip *)pep->ep_data;
		if (pip->ip_proto != IPP_UDP) {
			/* TODO: Drop icmp errors? */
			freebuf (pep);
			continue;
		}
		pudp = (struct udp *)((char *)pip + IP_HLEN(pip));

		if (net2hs (pip->ip_len) < IP_HLEN(pip) + UDP_HLEN
		    || net2hs (pudp->udp_len) < UDP_HLEN
		    || net2hs (pip->ip_len) < net2hs (pudp->udp_len) + UDP_HLEN
		    || (pudp->udp_cksum && udpcksum (pip, pudp))) {
			freebuf (pep);
			continue;
		}

		partial = -1;
		wait (Udp.devmutex);
		for (i = 0; i < Nudp; i++) {
			if (ucbtab[i].ucb_state != UCB_OPEN)
				continue;

			if (ucbtab[i].ucb_rip == IPADDR_ANY) {
				if (ucbtab[i].ucb_lip != IPADDR_ANY
				    && pip->ip_dst != ucbtab[i].ucb_lip)
					continue;
				if (pudp->udp_dst == ucbtab[i].ucb_lport
				    && (partial == -1
				        || ucbtab[partial].ucb_lip == IPADDR_ANY))
					partial = i;
			} else {
				if (pip->ip_dst == ucbtab[i].ucb_lip
				    && pip->ip_src == ucbtab[i].ucb_rip
				    && pudp->udp_dst == ucbtab[i].ucb_lport
				    && pudp->udp_src == ucbtab[i].ucb_rport)
					break;
			}
		}
		if (i == Nudp) {
			if (partial != -1) {
				i = partial;
			} else {
				icmpreply (ICMPT_DESTUR, ICMPC_PORTUR, 0, pep);
				freebuf (pep);
				signal (Udp.devmutex);
				continue;
			}
		}
		if (mqsend (ucbtab[i].ucb_mq, (int)pep) == SYSERR)
			freebuf(pep);
		signal (Udp.devmutex);
	}
}
