#include <conf.h>
#include <kernel.h>
#include <network.h>

u_short udpcksum (struct ip *pip, struct udp *pudp)
{
	unsigned int sum = 0;
	u_short *ptr;
	int i, len;

	ptr = (u_short *)&pip->ip_src;
	for (i = 0; i < 4; i++)
		sum += *ptr++;
	sum += (hs2net (pip->ip_proto));
	sum += pudp->udp_len;
	len = net2hs (pudp->udp_len);
	if (len % 2) {
		pudp->udp_data[len - UDP_HLEN] = 0;
		len++;
	}
	sum += ~cksum (pudp, len) & 0xffff;
	sum = (sum & 0xffff) + (sum >> 16);
	return ~((sum & 0xffff) + (sum >> 16)) & 0xffff;
}
