#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <bufpool.h>
#include <stdio.h>
#include <mq.h>

int udpclose (struct devsw *pdev)
{
	STATWORD ps;
	struct ucb *pucb = &ucbtab[pdev->dvminor];

	wait (Udp.devmutex);
	if (pucb->ucb_state != UCB_OPEN) {
		signal (Udp.devmutex);
		return SYSERR;
	}
	pucb->ucb_state = UCB_DELETING;
	pucb->ucb_lip = IPADDR_ANY;
	pucb->ucb_lport = UDPP_ANY;
	pucb->ucb_rip = IPADDR_ANY;
	pucb->ucb_rport = UDPP_ANY;
	disable(ps);
	pucb->ucb_cookie++;
	restore(ps);
	signal (Udp.devmutex);

	mqdisable (pucb->ucb_mq);
	mqclear (pucb->ucb_mq, (int (*)(int))freebuf);

	wait (Udp.devmutex);
	pucb->ucb_state = UCB_FREE;
	signal (Udp.devmutex);

	return OK;
}
