#include <conf.h>
#include <kernel.h>
#include <network.h>
#include <mq.h>
#include <udp.h>

int udpcntl (struct devsw *pdev, int func, int arg)
{
	int rv = SYSERR;
	struct ucb *pucb = (struct ucb *)&ucbtab[pdev->dvminor];

	wait (Udp.devmutex);
	switch (func) {
	case UDPC_CKSUM:
		if (arg)
			pucb->ucb_flags |= UCBF_CKSUM;
		else
			pucb->ucb_flags &= ~UCBF_CKSUM;
		rv = OK;
		break;
	case UDPC_TTL:
		if (arg == 0) {
			pucb->ucb_flags &= ~UCBF_TTL;
			rv = OK;
		} else if (arg > 0 && arg <= 255) {
			pucb->ucb_flags |= UCBF_TTL;
			pucb->ucb_ttl = arg;
			rv = OK;
		}
		break;
	case UDPC_BREAK:
		mqsend(pucb->ucb_mq, 0);
		break;
	}
	signal (Udp.devmutex);
	return rv;
}
